<?php
/**
 * LineFormat
 *
 * PHP version 5
 *
 * @category Class
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/* 
 * <summary>
 *  Copyright (c) 2020 Aspose.Cells Cloud
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 * 
 *  The above copyright notice and this permission notice shall be included in all 
 *  copies or substantial portions of the Software.
 * 
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 * </summary>
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Aspose\Cells\Cloud\Model;

use \ArrayAccess;
use \Aspose\Cells\Cloud\ObjectSerializer;

/**
 * LineFormat Class Doc Comment
 *
 * @category Class
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class LineFormat implements  ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'LineFormat';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'texture_fill' => '\Aspose\Cells\Cloud\Model\TextureFill',
        'image_data' => 'string',
        'pattern_fill' => '\Aspose\Cells\Cloud\Model\PatternFill',
        'solid_fill' => '\Aspose\Cells\Cloud\Model\SolidFill',
        'gradient_fill' => '\Aspose\Cells\Cloud\Model\GradientFill',
        'type' => 'string',
        'begin_arrowhead_length' => 'string',
        'dash_style' => 'string',
        'end_arrowhead_width' => 'string',
        'end_arrowhead_length' => 'string',
        'begin_arrowhead_width' => 'string',
        'compound_type' => 'string',
        'join_type' => 'string',
        'weight' => 'double',
        'begin_arrowhead_style' => 'string',
        'end_arrowhead_style' => 'string',
        'cap_type' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'texture_fill' => null,
        'image_data' => 'byte',
        'pattern_fill' => null,
        'solid_fill' => null,
        'gradient_fill' => null,
        'type' => null,
        'begin_arrowhead_length' => null,
        'dash_style' => null,
        'end_arrowhead_width' => null,
        'end_arrowhead_length' => null,
        'begin_arrowhead_width' => null,
        'compound_type' => null,
        'join_type' => null,
        'weight' => 'double',
        'begin_arrowhead_style' => null,
        'end_arrowhead_style' => null,
        'cap_type' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'texture_fill' => 'TextureFill',
        'image_data' => 'ImageData',
        'pattern_fill' => 'PatternFill',
        'solid_fill' => 'SolidFill',
        'gradient_fill' => 'GradientFill',
        'type' => 'Type',
        'begin_arrowhead_length' => 'BeginArrowheadLength',
        'dash_style' => 'DashStyle',
        'end_arrowhead_width' => 'EndArrowheadWidth',
        'end_arrowhead_length' => 'EndArrowheadLength',
        'begin_arrowhead_width' => 'BeginArrowheadWidth',
        'compound_type' => 'CompoundType',
        'join_type' => 'JoinType',
        'weight' => 'Weight',
        'begin_arrowhead_style' => 'BeginArrowheadStyle',
        'end_arrowhead_style' => 'EndArrowheadStyle',
        'cap_type' => 'CapType'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'texture_fill' => 'setTextureFill',
        'image_data' => 'setImageData',
        'pattern_fill' => 'setPatternFill',
        'solid_fill' => 'setSolidFill',
        'gradient_fill' => 'setGradientFill',
        'type' => 'setType',
        'begin_arrowhead_length' => 'setBeginArrowheadLength',
        'dash_style' => 'setDashStyle',
        'end_arrowhead_width' => 'setEndArrowheadWidth',
        'end_arrowhead_length' => 'setEndArrowheadLength',
        'begin_arrowhead_width' => 'setBeginArrowheadWidth',
        'compound_type' => 'setCompoundType',
        'join_type' => 'setJoinType',
        'weight' => 'setWeight',
        'begin_arrowhead_style' => 'setBeginArrowheadStyle',
        'end_arrowhead_style' => 'setEndArrowheadStyle',
        'cap_type' => 'setCapType'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'texture_fill' => 'getTextureFill',
        'image_data' => 'getImageData',
        'pattern_fill' => 'getPatternFill',
        'solid_fill' => 'getSolidFill',
        'gradient_fill' => 'getGradientFill',
        'type' => 'getType',
        'begin_arrowhead_length' => 'getBeginArrowheadLength',
        'dash_style' => 'getDashStyle',
        'end_arrowhead_width' => 'getEndArrowheadWidth',
        'end_arrowhead_length' => 'getEndArrowheadLength',
        'begin_arrowhead_width' => 'getBeginArrowheadWidth',
        'compound_type' => 'getCompoundType',
        'join_type' => 'getJoinType',
        'weight' => 'getWeight',
        'begin_arrowhead_style' => 'getBeginArrowheadStyle',
        'end_arrowhead_style' => 'getEndArrowheadStyle',
        'cap_type' => 'getCapType'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['texture_fill'] = isset($data['texture_fill']) ? $data['texture_fill'] : null;
        $this->container['image_data'] = isset($data['image_data']) ? $data['image_data'] : null;
        $this->container['pattern_fill'] = isset($data['pattern_fill']) ? $data['pattern_fill'] : null;
        $this->container['solid_fill'] = isset($data['solid_fill']) ? $data['solid_fill'] : null;
        $this->container['gradient_fill'] = isset($data['gradient_fill']) ? $data['gradient_fill'] : null;
        $this->container['type'] = isset($data['type']) ? $data['type'] : null;
        $this->container['begin_arrowhead_length'] = isset($data['begin_arrowhead_length']) ? $data['begin_arrowhead_length'] : null;
        $this->container['dash_style'] = isset($data['dash_style']) ? $data['dash_style'] : null;
        $this->container['end_arrowhead_width'] = isset($data['end_arrowhead_width']) ? $data['end_arrowhead_width'] : null;
        $this->container['end_arrowhead_length'] = isset($data['end_arrowhead_length']) ? $data['end_arrowhead_length'] : null;
        $this->container['begin_arrowhead_width'] = isset($data['begin_arrowhead_width']) ? $data['begin_arrowhead_width'] : null;
        $this->container['compound_type'] = isset($data['compound_type']) ? $data['compound_type'] : null;
        $this->container['join_type'] = isset($data['join_type']) ? $data['join_type'] : null;
        $this->container['weight'] = isset($data['weight']) ? $data['weight'] : null;
        $this->container['begin_arrowhead_style'] = isset($data['begin_arrowhead_style']) ? $data['begin_arrowhead_style'] : null;
        $this->container['end_arrowhead_style'] = isset($data['end_arrowhead_style']) ? $data['end_arrowhead_style'] : null;
        $this->container['cap_type'] = isset($data['cap_type']) ? $data['cap_type'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['image_data']) && !preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['image_data'])) {
            $invalidProperties[] = "invalid value for 'image_data', must be conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.";
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['image_data'])) {
            return false;
        }
        return true;
    }


    /**
     * Gets texture_fill
     *
     * @return \Aspose\Cells\Cloud\Model\TextureFill
     */
    public function getTextureFill()
    {
        return $this->container['texture_fill'];
    }

    /**
     * Sets texture_fill
     *
     * @param \Aspose\Cells\Cloud\Model\TextureFill $texture_fill texture_fill
     *
     * @return $this
     */
    public function setTextureFill($texture_fill)
    {
        $this->container['texture_fill'] = $texture_fill;

        return $this;
    }

    /**
     * Gets image_data
     *
     * @return string
     */
    public function getImageData()
    {
        return $this->container['image_data'];
    }

    /**
     * Sets image_data
     *
     * @param string $image_data image_data
     *
     * @return $this
     */
    public function setImageData($image_data)
    {

        if (!is_null($image_data) && (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $image_data))) {
            throw new \InvalidArgumentException("invalid value for $image_data when calling LineFormat., must conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.");
        }

        $this->container['image_data'] = $image_data;

        return $this;
    }

    /**
     * Gets pattern_fill
     *
     * @return \Aspose\Cells\Cloud\Model\PatternFill
     */
    public function getPatternFill()
    {
        return $this->container['pattern_fill'];
    }

    /**
     * Sets pattern_fill
     *
     * @param \Aspose\Cells\Cloud\Model\PatternFill $pattern_fill pattern_fill
     *
     * @return $this
     */
    public function setPatternFill($pattern_fill)
    {
        $this->container['pattern_fill'] = $pattern_fill;

        return $this;
    }

    /**
     * Gets solid_fill
     *
     * @return \Aspose\Cells\Cloud\Model\SolidFill
     */
    public function getSolidFill()
    {
        return $this->container['solid_fill'];
    }

    /**
     * Sets solid_fill
     *
     * @param \Aspose\Cells\Cloud\Model\SolidFill $solid_fill solid_fill
     *
     * @return $this
     */
    public function setSolidFill($solid_fill)
    {
        $this->container['solid_fill'] = $solid_fill;

        return $this;
    }

    /**
     * Gets gradient_fill
     *
     * @return \Aspose\Cells\Cloud\Model\GradientFill
     */
    public function getGradientFill()
    {
        return $this->container['gradient_fill'];
    }

    /**
     * Sets gradient_fill
     *
     * @param \Aspose\Cells\Cloud\Model\GradientFill $gradient_fill gradient_fill
     *
     * @return $this
     */
    public function setGradientFill($gradient_fill)
    {
        $this->container['gradient_fill'] = $gradient_fill;

        return $this;
    }

    /**
     * Gets type
     *
     * @return string
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param string $type type
     *
     * @return $this
     */
    public function setType($type)
    {
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets begin_arrowhead_length
     *
     * @return string
     */
    public function getBeginArrowheadLength()
    {
        return $this->container['begin_arrowhead_length'];
    }

    /**
     * Sets begin_arrowhead_length
     *
     * @param string $begin_arrowhead_length begin_arrowhead_length
     *
     * @return $this
     */
    public function setBeginArrowheadLength($begin_arrowhead_length)
    {
        $this->container['begin_arrowhead_length'] = $begin_arrowhead_length;

        return $this;
    }

    /**
     * Gets dash_style
     *
     * @return string
     */
    public function getDashStyle()
    {
        return $this->container['dash_style'];
    }

    /**
     * Sets dash_style
     *
     * @param string $dash_style dash_style
     *
     * @return $this
     */
    public function setDashStyle($dash_style)
    {
        $this->container['dash_style'] = $dash_style;

        return $this;
    }

    /**
     * Gets end_arrowhead_width
     *
     * @return string
     */
    public function getEndArrowheadWidth()
    {
        return $this->container['end_arrowhead_width'];
    }

    /**
     * Sets end_arrowhead_width
     *
     * @param string $end_arrowhead_width end_arrowhead_width
     *
     * @return $this
     */
    public function setEndArrowheadWidth($end_arrowhead_width)
    {
        $this->container['end_arrowhead_width'] = $end_arrowhead_width;

        return $this;
    }

    /**
     * Gets end_arrowhead_length
     *
     * @return string
     */
    public function getEndArrowheadLength()
    {
        return $this->container['end_arrowhead_length'];
    }

    /**
     * Sets end_arrowhead_length
     *
     * @param string $end_arrowhead_length end_arrowhead_length
     *
     * @return $this
     */
    public function setEndArrowheadLength($end_arrowhead_length)
    {
        $this->container['end_arrowhead_length'] = $end_arrowhead_length;

        return $this;
    }

    /**
     * Gets begin_arrowhead_width
     *
     * @return string
     */
    public function getBeginArrowheadWidth()
    {
        return $this->container['begin_arrowhead_width'];
    }

    /**
     * Sets begin_arrowhead_width
     *
     * @param string $begin_arrowhead_width begin_arrowhead_width
     *
     * @return $this
     */
    public function setBeginArrowheadWidth($begin_arrowhead_width)
    {
        $this->container['begin_arrowhead_width'] = $begin_arrowhead_width;

        return $this;
    }

    /**
     * Gets compound_type
     *
     * @return string
     */
    public function getCompoundType()
    {
        return $this->container['compound_type'];
    }

    /**
     * Sets compound_type
     *
     * @param string $compound_type compound_type
     *
     * @return $this
     */
    public function setCompoundType($compound_type)
    {
        $this->container['compound_type'] = $compound_type;

        return $this;
    }

    /**
     * Gets join_type
     *
     * @return string
     */
    public function getJoinType()
    {
        return $this->container['join_type'];
    }

    /**
     * Sets join_type
     *
     * @param string $join_type join_type
     *
     * @return $this
     */
    public function setJoinType($join_type)
    {
        $this->container['join_type'] = $join_type;

        return $this;
    }

    /**
     * Gets weight
     *
     * @return double
     */
    public function getWeight()
    {
        return $this->container['weight'];
    }

    /**
     * Sets weight
     *
     * @param double $weight weight
     *
     * @return $this
     */
    public function setWeight($weight)
    {
        $this->container['weight'] = $weight;

        return $this;
    }

    /**
     * Gets begin_arrowhead_style
     *
     * @return string
     */
    public function getBeginArrowheadStyle()
    {
        return $this->container['begin_arrowhead_style'];
    }

    /**
     * Sets begin_arrowhead_style
     *
     * @param string $begin_arrowhead_style begin_arrowhead_style
     *
     * @return $this
     */
    public function setBeginArrowheadStyle($begin_arrowhead_style)
    {
        $this->container['begin_arrowhead_style'] = $begin_arrowhead_style;

        return $this;
    }

    /**
     * Gets end_arrowhead_style
     *
     * @return string
     */
    public function getEndArrowheadStyle()
    {
        return $this->container['end_arrowhead_style'];
    }

    /**
     * Sets end_arrowhead_style
     *
     * @param string $end_arrowhead_style end_arrowhead_style
     *
     * @return $this
     */
    public function setEndArrowheadStyle($end_arrowhead_style)
    {
        $this->container['end_arrowhead_style'] = $end_arrowhead_style;

        return $this;
    }

    /**
     * Gets cap_type
     *
     * @return string
     */
    public function getCapType()
    {
        return $this->container['cap_type'];
    }

    /**
     * Sets cap_type
     *
     * @param string $cap_type cap_type
     *
     * @return $this
     */
    public function setCapType($cap_type)
    {
        $this->container['cap_type'] = $cap_type;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


