<?php
/**
 * Style
 *
 * PHP version 5
 *
 * @category Class
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/* 
 * <summary>
 *  Copyright (c) 2020 Aspose.Cells Cloud
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 * 
 *  The above copyright notice and this permission notice shall be included in all 
 *  copies or substantial portions of the Software.
 * 
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 * </summary>
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Aspose\Cells\Cloud\Model;

use \ArrayAccess;
use \Aspose\Cells\Cloud\ObjectSerializer;

/**
 * Style Class Doc Comment
 *
 * @category Class
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class Style implements  ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'Style';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'link' => '\Aspose\Cells\Cloud\Model\Link',
        'pattern' => 'string',
        'text_direction' => 'string',
        'custom' => 'string',
        'shrink_to_fit' => 'bool',
        'is_date_time' => 'bool',
        'culture_custom' => 'string',
        'rotation_angle' => 'int',
        'indent_level' => 'int',
        'is_percent' => 'bool',
        'foreground_color' => '\Aspose\Cells\Cloud\Model\Color',
        'name' => 'string',
        'foreground_theme_color' => '\Aspose\Cells\Cloud\Model\ThemeColor',
        'border_collection' => '\Aspose\Cells\Cloud\Model\Border[]',
        'is_locked' => 'bool',
        'vertical_alignment' => 'string',
        'background_color' => '\Aspose\Cells\Cloud\Model\Color',
        'background_theme_color' => '\Aspose\Cells\Cloud\Model\ThemeColor',
        'is_formula_hidden' => 'bool',
        'is_gradient' => 'bool',
        'number' => 'int',
        'horizontal_alignment' => 'string',
        'is_text_wrapped' => 'bool',
        'font' => '\Aspose\Cells\Cloud\Model\Font'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'link' => null,
        'pattern' => null,
        'text_direction' => null,
        'custom' => null,
        'shrink_to_fit' => null,
        'is_date_time' => null,
        'culture_custom' => null,
        'rotation_angle' => 'int32',
        'indent_level' => 'int32',
        'is_percent' => null,
        'foreground_color' => null,
        'name' => null,
        'foreground_theme_color' => null,
        'border_collection' => null,
        'is_locked' => null,
        'vertical_alignment' => null,
        'background_color' => null,
        'background_theme_color' => null,
        'is_formula_hidden' => null,
        'is_gradient' => null,
        'number' => 'int32',
        'horizontal_alignment' => null,
        'is_text_wrapped' => null,
        'font' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'link' => 'link',
        'pattern' => 'Pattern',
        'text_direction' => 'TextDirection',
        'custom' => 'Custom',
        'shrink_to_fit' => 'ShrinkToFit',
        'is_date_time' => 'IsDateTime',
        'culture_custom' => 'CultureCustom',
        'rotation_angle' => 'RotationAngle',
        'indent_level' => 'IndentLevel',
        'is_percent' => 'IsPercent',
        'foreground_color' => 'ForegroundColor',
        'name' => 'Name',
        'foreground_theme_color' => 'ForegroundThemeColor',
        'border_collection' => 'BorderCollection',
        'is_locked' => 'IsLocked',
        'vertical_alignment' => 'VerticalAlignment',
        'background_color' => 'BackgroundColor',
        'background_theme_color' => 'BackgroundThemeColor',
        'is_formula_hidden' => 'IsFormulaHidden',
        'is_gradient' => 'IsGradient',
        'number' => 'Number',
        'horizontal_alignment' => 'HorizontalAlignment',
        'is_text_wrapped' => 'IsTextWrapped',
        'font' => 'Font'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'link' => 'setLink',
        'pattern' => 'setPattern',
        'text_direction' => 'setTextDirection',
        'custom' => 'setCustom',
        'shrink_to_fit' => 'setShrinkToFit',
        'is_date_time' => 'setIsDateTime',
        'culture_custom' => 'setCultureCustom',
        'rotation_angle' => 'setRotationAngle',
        'indent_level' => 'setIndentLevel',
        'is_percent' => 'setIsPercent',
        'foreground_color' => 'setForegroundColor',
        'name' => 'setName',
        'foreground_theme_color' => 'setForegroundThemeColor',
        'border_collection' => 'setBorderCollection',
        'is_locked' => 'setIsLocked',
        'vertical_alignment' => 'setVerticalAlignment',
        'background_color' => 'setBackgroundColor',
        'background_theme_color' => 'setBackgroundThemeColor',
        'is_formula_hidden' => 'setIsFormulaHidden',
        'is_gradient' => 'setIsGradient',
        'number' => 'setNumber',
        'horizontal_alignment' => 'setHorizontalAlignment',
        'is_text_wrapped' => 'setIsTextWrapped',
        'font' => 'setFont'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'link' => 'getLink',
        'pattern' => 'getPattern',
        'text_direction' => 'getTextDirection',
        'custom' => 'getCustom',
        'shrink_to_fit' => 'getShrinkToFit',
        'is_date_time' => 'getIsDateTime',
        'culture_custom' => 'getCultureCustom',
        'rotation_angle' => 'getRotationAngle',
        'indent_level' => 'getIndentLevel',
        'is_percent' => 'getIsPercent',
        'foreground_color' => 'getForegroundColor',
        'name' => 'getName',
        'foreground_theme_color' => 'getForegroundThemeColor',
        'border_collection' => 'getBorderCollection',
        'is_locked' => 'getIsLocked',
        'vertical_alignment' => 'getVerticalAlignment',
        'background_color' => 'getBackgroundColor',
        'background_theme_color' => 'getBackgroundThemeColor',
        'is_formula_hidden' => 'getIsFormulaHidden',
        'is_gradient' => 'getIsGradient',
        'number' => 'getNumber',
        'horizontal_alignment' => 'getHorizontalAlignment',
        'is_text_wrapped' => 'getIsTextWrapped',
        'font' => 'getFont'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['link'] = isset($data['link']) ? $data['link'] : null;
        $this->container['pattern'] = isset($data['pattern']) ? $data['pattern'] : null;
        $this->container['text_direction'] = isset($data['text_direction']) ? $data['text_direction'] : null;
        $this->container['custom'] = isset($data['custom']) ? $data['custom'] : null;
        $this->container['shrink_to_fit'] = isset($data['shrink_to_fit']) ? $data['shrink_to_fit'] : null;
        $this->container['is_date_time'] = isset($data['is_date_time']) ? $data['is_date_time'] : null;
        $this->container['culture_custom'] = isset($data['culture_custom']) ? $data['culture_custom'] : null;
        $this->container['rotation_angle'] = isset($data['rotation_angle']) ? $data['rotation_angle'] : null;
        $this->container['indent_level'] = isset($data['indent_level']) ? $data['indent_level'] : null;
        $this->container['is_percent'] = isset($data['is_percent']) ? $data['is_percent'] : null;
        $this->container['foreground_color'] = isset($data['foreground_color']) ? $data['foreground_color'] : null;
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['foreground_theme_color'] = isset($data['foreground_theme_color']) ? $data['foreground_theme_color'] : null;
        $this->container['border_collection'] = isset($data['border_collection']) ? $data['border_collection'] : null;
        $this->container['is_locked'] = isset($data['is_locked']) ? $data['is_locked'] : null;
        $this->container['vertical_alignment'] = isset($data['vertical_alignment']) ? $data['vertical_alignment'] : null;
        $this->container['background_color'] = isset($data['background_color']) ? $data['background_color'] : null;
        $this->container['background_theme_color'] = isset($data['background_theme_color']) ? $data['background_theme_color'] : null;
        $this->container['is_formula_hidden'] = isset($data['is_formula_hidden']) ? $data['is_formula_hidden'] : null;
        $this->container['is_gradient'] = isset($data['is_gradient']) ? $data['is_gradient'] : null;
        $this->container['number'] = isset($data['number']) ? $data['number'] : null;
        $this->container['horizontal_alignment'] = isset($data['horizontal_alignment']) ? $data['horizontal_alignment'] : null;
        $this->container['is_text_wrapped'] = isset($data['is_text_wrapped']) ? $data['is_text_wrapped'] : null;
        $this->container['font'] = isset($data['font']) ? $data['font'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets link
     *
     * @return \Aspose\Cells\Cloud\Model\Link
     */
    public function getLink()
    {
        return $this->container['link'];
    }

    /**
     * Sets link
     *
     * @param \Aspose\Cells\Cloud\Model\Link $link link
     *
     * @return $this
     */
    public function setLink($link)
    {
        $this->container['link'] = $link;

        return $this;
    }

    /**
     * Gets pattern
     *
     * @return string
     */
    public function getPattern()
    {
        return $this->container['pattern'];
    }

    /**
     * Sets pattern
     *
     * @param string $pattern pattern
     *
     * @return $this
     */
    public function setPattern($pattern)
    {
        $this->container['pattern'] = $pattern;

        return $this;
    }

    /**
     * Gets text_direction
     *
     * @return string
     */
    public function getTextDirection()
    {
        return $this->container['text_direction'];
    }

    /**
     * Sets text_direction
     *
     * @param string $text_direction text_direction
     *
     * @return $this
     */
    public function setTextDirection($text_direction)
    {
        $this->container['text_direction'] = $text_direction;

        return $this;
    }

    /**
     * Gets custom
     *
     * @return string
     */
    public function getCustom()
    {
        return $this->container['custom'];
    }

    /**
     * Sets custom
     *
     * @param string $custom custom
     *
     * @return $this
     */
    public function setCustom($custom)
    {
        $this->container['custom'] = $custom;

        return $this;
    }

    /**
     * Gets shrink_to_fit
     *
     * @return bool
     */
    public function getShrinkToFit()
    {
        return $this->container['shrink_to_fit'];
    }

    /**
     * Sets shrink_to_fit
     *
     * @param bool $shrink_to_fit shrink_to_fit
     *
     * @return $this
     */
    public function setShrinkToFit($shrink_to_fit)
    {
        $this->container['shrink_to_fit'] = $shrink_to_fit;

        return $this;
    }

    /**
     * Gets is_date_time
     *
     * @return bool
     */
    public function getIsDateTime()
    {
        return $this->container['is_date_time'];
    }

    /**
     * Sets is_date_time
     *
     * @param bool $is_date_time is_date_time
     *
     * @return $this
     */
    public function setIsDateTime($is_date_time)
    {
        $this->container['is_date_time'] = $is_date_time;

        return $this;
    }

    /**
     * Gets culture_custom
     *
     * @return string
     */
    public function getCultureCustom()
    {
        return $this->container['culture_custom'];
    }

    /**
     * Sets culture_custom
     *
     * @param string $culture_custom culture_custom
     *
     * @return $this
     */
    public function setCultureCustom($culture_custom)
    {
        $this->container['culture_custom'] = $culture_custom;

        return $this;
    }

    /**
     * Gets rotation_angle
     *
     * @return int
     */
    public function getRotationAngle()
    {
        return $this->container['rotation_angle'];
    }

    /**
     * Sets rotation_angle
     *
     * @param int $rotation_angle rotation_angle
     *
     * @return $this
     */
    public function setRotationAngle($rotation_angle)
    {
        $this->container['rotation_angle'] = $rotation_angle;

        return $this;
    }

    /**
     * Gets indent_level
     *
     * @return int
     */
    public function getIndentLevel()
    {
        return $this->container['indent_level'];
    }

    /**
     * Sets indent_level
     *
     * @param int $indent_level indent_level
     *
     * @return $this
     */
    public function setIndentLevel($indent_level)
    {
        $this->container['indent_level'] = $indent_level;

        return $this;
    }

    /**
     * Gets is_percent
     *
     * @return bool
     */
    public function getIsPercent()
    {
        return $this->container['is_percent'];
    }

    /**
     * Sets is_percent
     *
     * @param bool $is_percent is_percent
     *
     * @return $this
     */
    public function setIsPercent($is_percent)
    {
        $this->container['is_percent'] = $is_percent;

        return $this;
    }

    /**
     * Gets foreground_color
     *
     * @return \Aspose\Cells\Cloud\Model\Color
     */
    public function getForegroundColor()
    {
        return $this->container['foreground_color'];
    }

    /**
     * Sets foreground_color
     *
     * @param \Aspose\Cells\Cloud\Model\Color $foreground_color foreground_color
     *
     * @return $this
     */
    public function setForegroundColor($foreground_color)
    {
        $this->container['foreground_color'] = $foreground_color;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string $name name
     *
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets foreground_theme_color
     *
     * @return \Aspose\Cells\Cloud\Model\ThemeColor
     */
    public function getForegroundThemeColor()
    {
        return $this->container['foreground_theme_color'];
    }

    /**
     * Sets foreground_theme_color
     *
     * @param \Aspose\Cells\Cloud\Model\ThemeColor $foreground_theme_color foreground_theme_color
     *
     * @return $this
     */
    public function setForegroundThemeColor($foreground_theme_color)
    {
        $this->container['foreground_theme_color'] = $foreground_theme_color;

        return $this;
    }

    /**
     * Gets border_collection
     *
     * @return \Aspose\Cells\Cloud\Model\Border[]
     */
    public function getBorderCollection()
    {
        return $this->container['border_collection'];
    }

    /**
     * Sets border_collection
     *
     * @param \Aspose\Cells\Cloud\Model\Border[] $border_collection border_collection
     *
     * @return $this
     */
    public function setBorderCollection($border_collection)
    {
        $this->container['border_collection'] = $border_collection;

        return $this;
    }

    /**
     * Gets is_locked
     *
     * @return bool
     */
    public function getIsLocked()
    {
        return $this->container['is_locked'];
    }

    /**
     * Sets is_locked
     *
     * @param bool $is_locked is_locked
     *
     * @return $this
     */
    public function setIsLocked($is_locked)
    {
        $this->container['is_locked'] = $is_locked;

        return $this;
    }

    /**
     * Gets vertical_alignment
     *
     * @return string
     */
    public function getVerticalAlignment()
    {
        return $this->container['vertical_alignment'];
    }

    /**
     * Sets vertical_alignment
     *
     * @param string $vertical_alignment vertical_alignment
     *
     * @return $this
     */
    public function setVerticalAlignment($vertical_alignment)
    {
        $this->container['vertical_alignment'] = $vertical_alignment;

        return $this;
    }

    /**
     * Gets background_color
     *
     * @return \Aspose\Cells\Cloud\Model\Color
     */
    public function getBackgroundColor()
    {
        return $this->container['background_color'];
    }

    /**
     * Sets background_color
     *
     * @param \Aspose\Cells\Cloud\Model\Color $background_color background_color
     *
     * @return $this
     */
    public function setBackgroundColor($background_color)
    {
        $this->container['background_color'] = $background_color;

        return $this;
    }

    /**
     * Gets background_theme_color
     *
     * @return \Aspose\Cells\Cloud\Model\ThemeColor
     */
    public function getBackgroundThemeColor()
    {
        return $this->container['background_theme_color'];
    }

    /**
     * Sets background_theme_color
     *
     * @param \Aspose\Cells\Cloud\Model\ThemeColor $background_theme_color background_theme_color
     *
     * @return $this
     */
    public function setBackgroundThemeColor($background_theme_color)
    {
        $this->container['background_theme_color'] = $background_theme_color;

        return $this;
    }

    /**
     * Gets is_formula_hidden
     *
     * @return bool
     */
    public function getIsFormulaHidden()
    {
        return $this->container['is_formula_hidden'];
    }

    /**
     * Sets is_formula_hidden
     *
     * @param bool $is_formula_hidden is_formula_hidden
     *
     * @return $this
     */
    public function setIsFormulaHidden($is_formula_hidden)
    {
        $this->container['is_formula_hidden'] = $is_formula_hidden;

        return $this;
    }

    /**
     * Gets is_gradient
     *
     * @return bool
     */
    public function getIsGradient()
    {
        return $this->container['is_gradient'];
    }

    /**
     * Sets is_gradient
     *
     * @param bool $is_gradient is_gradient
     *
     * @return $this
     */
    public function setIsGradient($is_gradient)
    {
        $this->container['is_gradient'] = $is_gradient;

        return $this;
    }

    /**
     * Gets number
     *
     * @return int
     */
    public function getNumber()
    {
        return $this->container['number'];
    }

    /**
     * Sets number
     *
     * @param int $number number
     *
     * @return $this
     */
    public function setNumber($number)
    {
        $this->container['number'] = $number;

        return $this;
    }

    /**
     * Gets horizontal_alignment
     *
     * @return string
     */
    public function getHorizontalAlignment()
    {
        return $this->container['horizontal_alignment'];
    }

    /**
     * Sets horizontal_alignment
     *
     * @param string $horizontal_alignment horizontal_alignment
     *
     * @return $this
     */
    public function setHorizontalAlignment($horizontal_alignment)
    {
        $this->container['horizontal_alignment'] = $horizontal_alignment;

        return $this;
    }

    /**
     * Gets is_text_wrapped
     *
     * @return bool
     */
    public function getIsTextWrapped()
    {
        return $this->container['is_text_wrapped'];
    }

    /**
     * Sets is_text_wrapped
     *
     * @param bool $is_text_wrapped is_text_wrapped
     *
     * @return $this
     */
    public function setIsTextWrapped($is_text_wrapped)
    {
        $this->container['is_text_wrapped'] = $is_text_wrapped;

        return $this;
    }

    /**
     * Gets font
     *
     * @return \Aspose\Cells\Cloud\Model\Font
     */
    public function getFont()
    {
        return $this->container['font'];
    }

    /**
     * Sets font
     *
     * @param \Aspose\Cells\Cloud\Model\Font $font font
     *
     * @return $this
     */
    public function setFont($font)
    {
        $this->container['font'] = $font;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


